// $Id: jogshuttle.h,v 1.4.2.3 2003/01/23 22:01:35 freefrag Exp $

/*
 * Copyright (C) 2001 Tomoaki Hayasaka <hayasakas@postman.riken.go.jp>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef JOGSHUTTLE_H
#define JOGSHUTTLE_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <gnome.h>

#define USE_HID_JOGSHUTTLE

typedef void ( *JogShuttleCallback ) (void *, unsigned short, unsigned short);

class JogShuttle
{
private:
	static JogShuttle *_instance;
	JogShuttleCallback _callback;
	void * _callbackdata;

protected:
	friend void JogShuttle_inputCallback(gpointer data, gint source, 
										 GdkInputCondition condition);
	void inputCallback(gint source, GdkInputCondition condition);
	JogShuttle();

public:
	~JogShuttle();
	static JogShuttle &getInstance();
	void registerCallback(void * user, JogShuttleCallback callback);
	void deregisterCallback();

private:
	void jog(int dir);
	void shuttle(int angle);
	void button(int code);
	
	int input_;
	gint monitorTag_;
  
	/* Used to keep track of the inner dial in hid mode */
#ifdef USE_HID_JOGSHUTTLE
	unsigned int last_dial_value;
	unsigned int last_wheel_value;
	/* Used to keep track of "modifier" keys - only the buttons
	   can be used, only the code is used */
	unsigned short _modifier_code;
#endif
};

#endif
